<?php
/*****************************************************************
* SMF RateThatTopic									             *
******************************************************************/

// OK First load the stuff
global $smcFunc, $db_prefix, $context, $boarddir, $db_name, $db_passwd, $db_user, $db_server, $modSettings, $scripturl, $boardurl;

$doing_manual_install = false;

if (!defined('SMF') && file_exists(dirname(__FILE__) . '/SSI.php'))
{
	require_once(dirname(__FILE__) . '/SSI.php');
	$doing_manual_install = true;
}
elseif (!defined('SMF'))
	die('The installer wasn\'t able to connect to SMF! Make sure that you are either installing this via the Package Manager or the SSI.php file is in the same directory.');

// The whole "delete" part was copied from the SMF code. Thanks, guys!
if (isset($_GET['delete']))
{
	@unlink(__FILE__);

	header('Location: http://' . (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME'] . ':' . $_SERVER['SERVER_PORT']) . dirname($_SERVER['PHP_SELF']) . '/Themes/default/images/blank.gif');
	exit;
}

if ($doing_manual_install)
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head>
	<title>SMD RateThatTopic mod Database Installer</title>
     <link rel="stylesheet" type="text/css" href="Themes/default/style.css" />
</head>
<body>
	<br /><br />';


// Start it!
// First load the SMF 2's Extra DB Functions
db_extend('packages');
db_extend('extra');

// Get the table list
	$tables = array();
	$tmp = $smcFunc['db_list_tables']();
	foreach ($tmp as $t)
		if (substr($db_prefix,0,strlen($db_name) + 3) != '`'.$db_name.'`.')
			$tables[] = $t;
		else
			$tables[] = '`'.$db_name . '`.'.$t;

// Create the tables
$smcFunc['db_create_table'](
	'log_rt',
	array(
		array('name' => 'id_member','type' => 'MEDIUMINT','size' => '8','default' => 0,'null' => false),
		array('name' => 'id_topic','type' => 'MEDIUMINT','size' => '8','default' => 0,'null' => false),
		array('name' => 'rate','type' => 'SMALLINT','size' => '5','default' => 0,'null' => false),
		array('name' => 'time','type' => 'TEXT','null' => false),
	),
	array(
			array(
				'type' => 'primary',
				'columns' => array('id_topic')
			)
		),
	array(),
	'ignore'
);

$created_tables[] = 'log_rt';


$boards_columns = $smcFunc['db_list_columns']('boards', false);
$messages_columns = $smcFunc['db_list_columns']('messages', false);

if (!in_array('rateTopic_board_enable', $boards_columns))
{
	$smcFunc['db_add_column']('boards', array('name' => 'rateTopic_board_enable', 'type' => 'TINYINT','size' => '4', 'default' => '0', 'null' => false));
	$altered_mem_table_1 = true;
}
if (!in_array('rate', $messages_columns))
{
	$smcFunc['db_add_column']('messages', array('name' => 'rate', 'type' => 'FLOAT','size' => '5', 'default' => '0', 'null' => false));
	$altered_mem_table_2 = true;
}
else
{
	$smcFunc['db_change_column']('messages', 'rate', array('type' => 'float'));
	$altered_mem_table_3 = true;
}

// OK, time to report, output all the stuff to be shown to the user
echo '
<table cellpadding="0" cellspacing="0" border="0" class="tborder" width="750" align="center"><tr><td>
<div class="titlebg" style="padding: 1ex">
	SMF RateThatTopic mod Database Installer
</div>
<div class="windowbg2" style="padding: 2ex">';

// Tell them what has been done
echo '<b>Creating / Updating Tables</b>
<br /><br />
<ul class="normallist">';
foreach ($created_tables as $table_name)
	if (in_array($table_name, $tables))
		echo '
	<li>Table <i>'.preg_replace('/`[^`]+`\./', '', $table_name).'</i> already exists.</li>';
	else
		echo '
	<li>'.$table_name.' table created.</li>';
if ($altered_mem_table_1)
	echo '
	<li>Altered '.preg_replace('/`[^`]+`\./', '', $db_prefix).'boards table, added field "rateTopic_board_enable".</li>';
if ($altered_mem_table_2)
	echo '
	<li>Altered '.preg_replace('/`[^`]+`\./', '', $db_prefix).'messages table, added field "rate".</li>';
if ($altered_mem_table_3)
	echo '
	<li>Altered '.preg_replace('/`[^`]+`\./', '', $db_prefix).'messages table, modified field "rate" type to "float".</li>';
echo '
</ul>
	<br /><br /><b>Thank you for trying out SMF RateThatTopic mod!</b>
</div>
</td></tr></table>
<br />';

if ($doing_manual_install)
	echo '
</body></html>';

?>
